#include <maya/MFnPlugin.h>
#include "gpuCacher.h"

MStatus initializePlugin(MObject obj)
{
	MStatus status;
	MFnPlugin plugin(obj, "", "", "");

	status = plugin.registerNode("gpuCacher", gpuCacher::id, &gpuCacher::creator, &gpuCacher::initialize, MPxNode::kLocatorNode, &gpuCacher::drawDbClassification);
	if(!status)
	{
		status.perror("registerNode");
		return status;
	}

	status = MHWRender::MDrawRegistry::registerDrawOverrideCreator(gpuCacher::drawDbClassification, gpuCacher::drawRegistrantId, GpuCacherDrawOverride::Creator);
	if(!status)
	{
		status.perror("registerDrawOverrideCreator");
		return status;
	}

	return status;
}

MStatus uninitializePlugin(MObject obj)
{
	MStatus status;
	MFnPlugin plugin(obj);

	status = MHWRender::MDrawRegistry::deregisterDrawOverrideCreator(gpuCacher::drawDbClassification, gpuCacher::drawRegistrantId);
	if(!status)
	{
		status.perror("deregisterDrawOverrideCreator");
		return status;
	}

	status = plugin.deregisterNode(gpuCacher::id);
	if(!status)
	{
		status.perror("deregisterNode");
		return status;
	}

	return status;
}
